////////////////////////////////////////////////////////////////////////////////
//
//  Copyright (c) 2007 IWantGamez, LLC.  All rights reserved.
//  
//  Author: John Holben         Date: 04.28.2007
//
////////////////////////////////////////////////////////////////////////////////

// Constants 

// Audio
var WAV_SWAP = 0;
var WAV_MATCH = 1;
var WAV_HINT = 2;
var WAV_GAME_OVER = 3;
var WAV_GAME_START = 4;
var WAV_GAME_QUIT = 5;
var WAV_HI_SCORE = 6;
var WAV_BONUS = 7;

// From settings.js
var KEY_ENABLE_SOUND_FX = "SoundFX";
var KEY_HS_TIME = "HSTime";
var KEY_HS_GEMS = "HSGems";
var KEY_HS_MOVES = "HSMoves";
var KEY_HS_HINTS = "HSHints";

// Globals
var AUDIO = new AudioTemplate();

function Initialize()
{
    // Get audio going 
    AUDIO.Init();

    System.Gadget.onSettingsClosed = AUDIO.SettingsClosed;

    System.Gadget.settingsUI = "settings.html";
    logo.addGlow("black",2,30);


    // This is required so control is focused and Tool tips will display
    // before any clicking of the game pieces
    self.focus();
    document.body.focus();
}

function showTop10()
{
    System.Gadget.Flyout.file = 'top10.html'; 
    System.Gadget.Flyout.show = true;    
    AUDIO.Play(WAV_BONUS);
}    

function AudioTemplate()
{
    this.UseSoundFx = false;

    this.Waves = new Array( "swap.wav", "match.wav", "hint.wav", "gameOver.wav", "gameStart.wav", "gameQuit.wav", "hiScore.wav", "bonus.wav");

    this.Init = function()
        {
            this.UseSoundFx = System.Gadget.Settings.read(KEY_ENABLE_SOUND_FX);        

            // This is first time running - default to enabled            
            if(this.UseSoundFx == "")
            {
                this.UseSoundFx = true;
                //System.Gadget.Settings.write(KEY_ENABLE_SOUND_FX,this.UseSoundFx);
            }
        }
    
    this.Play = function(id)
        {
            if(this.UseSoundFx == true && id >= 0 && id < this.Waves.length)
            {
                System.Sound.playSound("Waves\\" + this.Waves[id]);            
            }
        }
        
    this.SettingsClosed = function(event)
        {
            if (event.closeAction == event.Action.commit)
            {
                AUDIO.UseSoundFx = System.Gadget.Settings.read(KEY_ENABLE_SOUND_FX); 
            }
        }
}

